version: "3.9"
services:
  minio:
    image: quay.io/minio/minio:RELEASE.2021-10-06T23-36-31Z
    restart: always
    container_name: minio
    networks:
      - traefik
      - s3
      - prometheus
    volumes:
      - /opt/cloudstack/minio/data:/data
    environment:
      MINIO_ROOT_USER: "{{ cloudstack.plugins.minio.config.user }}"
      MINIO_ROOT_PASSWORD: "{{ cloudstack.plugins.minio.config.password }}"
      MINIO_BROWSER_REDIRECT_URL: "https://{{ cloudstack.plugins.minio.config.console.sitename }}"
      MINIO_DOMAIN: s3.ayedo.de
      MINIO_PROMETHEUS_AUTH_TYPE: public
      MINIO_PROMETHEUS_URL: http://{{ cloudstack.plugins.minio.config.prometheus.host }}:9090
      MINIO_PROMETHEUS_JOB_ID: minio
    command: server --console-address ":9001" /data
    healthcheck:
      test: ["CMD", "curl", "-f", "http://localhost:9000/minio/health/live"]
      interval: 30s
      timeout: 20s
      retries: 3
    labels:
      - "traefik.enable=true"
      - "traefik.docker.network=traefik"
      - "traefik.http.middlewares.minio-compress.compress=true"
      - "traefik.http.services.minio.loadbalancer.server.port=9000"
      - "traefik.http.services.minio.loadbalancer.passhostheader=true"
      - "traefik.http.routers.minio.rule=Host(`{{ cloudstack.plugins.minio.config.sitename }}`)"
      - "traefik.http.routers.minio.service=minio"
      - "traefik.http.routers.minio.entrypoints=websecure"
      - "traefik.http.routers.minio.tls=true"
      - 'traefik.http.routers.minio.middlewares=allow-dashboard@docker,minio-compress@docker,redirect-to-https@docker'
      - "traefik.http.services.console.loadbalancer.server.port=9001"
      - "traefik.http.services.console.loadbalancer.passhostheader=true"
      - "traefik.http.routers.console.rule=Host(`{{ cloudstack.plugins.minio.config.console.sitename }}`)"
      - "traefik.http.routers.console.tls=true"
      - "traefik.http.routers.console.service=console"
      - "traefik.http.routers.console.entrypoints=websecure"
      - 'traefik.http.routers.console.middlewares=allow-dashboard@docker,redirect-to-https@docker,minio-authentik-proxy@docker'

  minio-authentik-proxy:
    image: ghcr.io/goauthentik/proxy:{{ cloudstack.plugins.authentik.version }}
    networks:
      - authentik
      - traefik
      - s3
    environment:
      AUTHENTIK_HOST: http://authentik:9000
      AUTHENTIK_INSECURE: "true"
      AUTHENTIK_TOKEN: {{ cloudstack.plugins.minio.config.authentik.token }}
      AUTHENTIK_HOST_BROWSER: https://{{ cloudstack.plugins.authentik.config.sitename }}
    labels:
      traefik.enable: true
      traefik.docker.network: traefik
      traefik.http.routers.minio-authentik-proxy.entrypoints: websecure
      traefik.http.routers.minio-authentik-proxy.service: minio-authentik-proxy
      traefik.http.services.minio-authentik-proxy.loadbalancer.server.port: 9000
      traefik.http.routers.minio-authentik-proxy.rule: Host(`{{ cloudstack.plugins.minio.config.console.sitename }}`) && PathPrefix(`/akprox/`)
      traefik.http.middlewares.minio-authentik-proxy.forwardauth.address: http://minio-authentik-proxy:9000/akprox/auth/traefik
      traefik.http.middlewares.minio-authentik-proxy.forwardauth.trustForwardHeader: true
      traefik.http.middlewares.minio-authentik-proxy.forwardauth.authResponseHeaders: X-authentik-username,X-authentik-groups,X-authentik-email,X-authentik-name,X-authentik-uid,X-authentik-jwt,X-authentik-meta-jwks,X-authentik-meta-outpost,X-authentik-meta-provider,X-authentik-meta-app,X-authentik-meta-version
    restart: unless-stopped

networks:
  traefik:
    external: true
  s3:
    name: s3
  prometheus:
    external: true
  authentik:
    external: true
